using System;
using System.Collections.Generic;
using System.Text;

namespace Eve.Data
{
    public class AssemblyLineTypeCategoryDetail : EveAssociation<AssemblyLineType, Category>
    {
        private double timeMultiplier;
        private double materialMultiplier;

        public AssemblyLineType AssemblyLineType
        {
            get { return From; }
        }
        public Category Category
        {
            get { return To; }
        }
        public double TimeMultiplier
        {
            get { return timeMultiplier; }
        }
        public double MaterialMultiplier
        {
            get { return materialMultiplier; }
        }

        internal AssemblyLineTypeCategoryDetail(DbDataRow dr)
            : base(dr.Database, new AssemblyLineType(dr.Database, dr["assemblyLineTypeID"]), new Category(dr.Database, dr["categoryID"]))
        {
            Fill(dr);
        }
        internal AssemblyLineTypeCategoryDetail(DbDataRow dr, AssemblyLineType type)
            : base(dr.Database, type, new Category(dr.Database, dr["categoryID"]))
        {
            Fill(dr);
        }

        private void Fill(DbDataRow dr)
        {
            timeMultiplier = dr["timeMultiplier"];
            materialMultiplier = dr["materialMultiplier"];
        }

    }
}
