using System;
using System.Collections.Generic;
using System.Text;

namespace Eve.Data
{
    public class AssemblyLineTypeGroupDetail : EveAssociation<AssemblyLineType, Group>
    {
        private double timeMultiplier;
        private double materialMultiplier;

        public AssemblyLineType AssemblyLineType
        {
            get { return From; }
        }
        public Group Group
        {
            get { return To; }
        }

        internal AssemblyLineTypeGroupDetail(DbDataRow dr)
            : base(dr.Database, new AssemblyLineType(dr.Database, dr["assemblyLineTypeID"]), new Group(dr.Database, dr["groupID"]))
        {
            Fill(dr);
        }
        internal AssemblyLineTypeGroupDetail(DbDataRow dr, AssemblyLineType type)
            : base(dr.Database, type, new Group(dr.Database, dr["groupID"]))
        {
            Fill(dr);
        }

        private void Fill(DbDataRow dr)
        {
            timeMultiplier = dr["timeMultiplier"];
            materialMultiplier = dr["materialMultiplier"];
        }
    }
}
