using System;
using System.Collections.Generic;
using System.Text;

namespace Eve.Data
{
    public class CorporationResearchField : EveAssociation<Type, Corporation>
    {
        private int supplierType;

        public Type Skill
        {
            get { return From; }
        }
        public Corporation Corporation
        {
            get { return To; }
        }
        public int SupplierType
        {
            get { return supplierType; }
        }

        internal CorporationResearchField(DbDataRow dr)
            : base(dr.Database, new Type(dr.Database, dr["skillID"]), new Corporation(dr.Database, dr["corporationID"]))
        {
            Fill(dr);
        }
        internal CorporationResearchField(DbDataRow dr, Corporation corp)
            : base(dr.Database, new Type(dr.Database, dr["skillID"]), corp)
        {
            Fill(dr);
        }

        private void Fill(DbDataRow dr)
        {
            supplierType = dr["supplierType"];
        }
    }
}
