using System;
using System.Collections.Generic;
using System.Text;

namespace Eve.Data
{
    public class RaceSkill : EveAssociation<Race, Type>
    {
        private int levels;

        public Race Race
        {
            get { return From; }
        }
        public Type Skill
        {
            get { return To; }
        }
        public int Levels
        {
            get { return levels; }
        }

        internal RaceSkill(DbDataRow dr)
            : base(dr.Database, new Race(dr.Database, dr["raceID"]), new Type(dr.Database, dr["skillID"]))
        {
            Fill(dr);
        }
        internal RaceSkill(DbDataRow dr, Race race)
            : base(dr.Database, race, new Type(dr.Database, dr["skillID"]))
        {
            Fill(dr);
        }

        private void Fill(DbDataRow dr)
        {
            levels = dr["levels"];
        }
    }
}
