using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SQLite;

namespace Eve.Data
{
#if (!WEB)
    internal class SQLiteDatabase : Database
    {
        SQLiteConnection conn;

        public SQLiteDatabase()
            : base(DatabaseType.SQLite)
        {
        }

        public override bool TableExists(string table)
        {
            return ExecuteScalar("SELECT COUNT(name) FROM sqlite_master WHERE type='table' AND name='" + table + "'");
        }

        protected override IDbConnection OpenConnection(string connectionString)
        {
            if (conn != null && conn.ConnectionString != connectionString)
            {
                conn.Close();
                conn = null;
            }
            if (conn == null) conn = new SQLiteConnection(connectionString);
            if (conn.State == ConnectionState.Closed || conn.State == ConnectionState.Broken) conn.Open();
            return conn;
        }
        protected override IDbDataAdapter GetDataAdapter(string query, string connectionString)
        {
            return new SQLiteDataAdapter(query, (SQLiteConnection)OpenConnection(connectionString));
        }
        protected override IDbCommand GetCommand(string query, string connectionString)
        {
            return new SQLiteCommand(query, (SQLiteConnection)OpenConnection(connectionString));
        }
    }
#endif
}
